extern WriteConsoleA		
extern ReadConsoleA
extern SetConsoleTitleA
extern GetStdHandle
extern wsprintfA
extern ExitProcess
extern WriteFile

section .data

hStdOut dd 0
hStdIn dd 0
Titolo db 'Esempio di operazioni in console',0
TestoDaScrivere db 'Digita il tuo nome: '
DimTestoDaScrivere EQU $-TestoDaScrivere
DimDatiDaLeggere EQU 50
DatiLetti dd 0
TestoDaScrivere2 db 'Piacere di conoscerti, %s',0
NULL equ 0
STD_INPUT_HANDLE     equ	-10
STD_OUTPUT_HANDLE    equ	-11
INVALID_HANDLE_VALUE equ	0FFFFFFFFh


section .bss

DatiDaLeggere resb 100
Buffer resb 80



section .code use32

	global main
	
main:

	push dword Titolo
	call SetConsoleTitleA			;Cambiamo il titolo della finestra
	push dword STD_OUTPUT_HANDLE
	call GetStdHandle			;Mi trovo l'handle allo standard output della console
	cmp eax, INVALID_HANDLE_VALUE		;In caso la funzione GetStdHandle fallisca... usciamo	
	jz near esci

	
	;Poich tutte le funzioni API modificano eax, dobbiamo salvare l'handle appena ottenuto
	;per gli usi futuri....
	;Le funzioni API garantiscono che non verranno modificati i registri di segmento e 
	;ebx, esi, edi e ebp, ma per quanto riguarda gli altri... non potete chiamare una funzione API
 	;e pensare che vi rimetta a posto tutti i registri :)
	mov [hStdOut],eax				

	;Tutte le funzioni API tranne la wsprintf usano la convenzione stdcall... noi pushiamo sullo stack
	;i parametri, e la funzione chiamata rimette a posto lo stack prima di ritornare.
	;il quarto parametro  NULL perch a noi non interessa sapere quanti caratteri ha scritto...
	;voglio sperare infatti che me li abbia scritti tutti in questo semplice caso di esempio :)
	push dword NULL
	push dword NULL 
	push dword DimTestoDaScrivere
	push dword TestoDaScrivere
	push dword [hStdOut]
	call WriteConsoleA
	
	push dword STD_INPUT_HANDLE
	call GetStdHandle			;Mi trovo l'handle allo standard input della console
	cmp eax, INVALID_HANDLE_VALUE		;In caso la funzione GetStdHandle fallisca... usciamo	
	jz esci

	mov [hStdIn], eax
	
	;Leggiamo qualcosa dalla console
	push dword NULL
	push dword DatiLetti
	push dword DimDatiDaLeggere
	push dword DatiDaLeggere
	push dword [hStdIn]
	call ReadConsoleA
			
	;Questa funzione permette di costruire stringhe agevolmente :)
	push dword DatiDaLeggere
	push dword TestoDaScrivere2
	push dword Buffer
	call wsprintfA

	;Questa funzione API  l'unica che non toglie i parametri dallo stack da sola.
	pop ebx
	pop ebx
	pop ebx	

	;il valore di ritorno di wsprintf non tiene conto del nullchar finale, ma io voglio levare
	;il ritorno a capo che  in coda alla stringa, appena prima del nullchar.
	;normalmente non  un problema questo della wsprintf, visto che o sono io che gli dico gi
	;quanto  lunga la stringa (e allora non serve il nullchar) come per la WriteFile, 
	;o io non gli dico la dimensione (i.e.: MessageBoxA) e se lo trova la funzione 
	;da sola il nullchar :)
	dec eax

	;Stavolta usiamo l'altra API. Provate a cambiare la parola File con Console e ricompilate,
	;vedrete che funziona tutto alla perfezione
	push dword NULL
	push dword NULL
	push eax
	push dword Buffer
	push dword [hStdOut]
	call WriteFile
	

esci:
	;Tutti i programmi Win32 dovrebbero chiamare la ExitProcess per terminare il loro processo.. :)
	;Il parametro passato  il codice di uscita, che pu essere utile per far capire ad altri programmi
	;se tutto  andato bene o no ( come il vecchio errorlevel del DOS)
	push dword NULL	
	call ExitProcess