//colori
#define RED "\e[1;31m"
#define CLEAR "\e[0m"
#define BLUE "\e[1;34m"
//per la crypt
#define _XOPEN_SOURCES 
#include <unistd.h>

//free malloc
#include <stdlib.h>

//fopen fprintf fwrite fread fclose perror
#include <stdio.h>

//strcmp
#include <string.h>

void use();
void cod(char *stringa, char *key,unsigned int stringalen);
void decod(char *stringa, char *key,unsigned int stringalen);
int docheck(char *c,char *key);
char *check(char *key);

int main(int argc,char *argv[]){

 FILE *file;
 FILE *output;
 char *str;
 char *checks;

    if (argc<2){
    	fprintf(stderr,"\n%s Too few arguments\n",RED);
	fprintf(stderr," Type \"%s -h\" for help%s\n\n",argv[0],CLEAR);
	return 1;
    }

    if (argc<5 && strcmp(argv[1],"-h") &&  strcmp(argv[1],"--help")){
	fprintf(stderr,"\n%s Too few arguments\n",RED);
	fprintf(stderr," Type \"%s -h\" for help%s\n\n",argv[0],CLEAR);
	return 1;
    }
    
    str=(char *)malloc(110);

    //kryo -c file pass outputfile
    if (!strcmp(argv[1],"-c") || !strcmp(argv[1],"--crypt")){    
	int l;	

	//se i file sono uguali esce...
	if (!strcmp(argv[2],argv[4])){
	    fprintf(stderr,"\n%s The input and the output file can't be the same%s\n\n",RED,CLEAR);
	    free(str);
	    return 1;
	}
	
	//qualke errore nell'aprire i file	
	if ((file=fopen(argv[2],"rb"))==NULL || (output=fopen(argv[4],"wb"))==NULL){
	    sprintf(str,"\n%s Error in input or output file: ",RED);
	    perror(str);
	    fprintf(stderr," Type \"%s -h\" for help%s\n\n",argv[0],CLEAR);
	    free(str);
	    return 1;
	}
	//calcola l'hash della pass e la mette nell'outputfile
	checks=check(argv[3]);
	fprintf(output,"%s",checks);
	free(checks);

	//legge tutto il file, e intento lo scrive criptato dentro l'outputfile
	while(l=fread(str,1,100,file)){
	    cod(str,argv[3],l);
	    fwrite(str,l,1,output);
        }

	free(str);
	fclose(file);
	fclose(output);
	return 0;
    }
    
    //kryo -d file pass output
    else if(!strcmp(argv[1],"-d") || !strcmp(argv[1],"--decrypt")){
	int l;

	//se i file sono uguali esce...
	if (!strcmp(argv[2],argv[4])){
	    fprintf(stderr,"\n%s The input and the output file can't be the same%s\n\n",RED,CLEAR);
	    free(str);
	    return 1;
	}

	//qualke errore nell'aprire i file	
	if ((file=fopen(argv[2],"rb"))==NULL || (output=fopen(argv[4],"wb"))==NULL){
	    sprintf(str,"\n%s Error in input or output file: ",RED);
	    perror(str);
	    fprintf(stderr," Type \"%s -h\" for help%s\n\n",argv[0],CLEAR);
	    free(str);
	    return 1;
	}

	//legge l'hash	
    	fread(str,2,1,file);

	//e controlla se la pass e' giusta
    	if (!docheck(str,argv[3])){
	    fprintf(stderr,"\n%s The key is not correct!%s\n\n",RED,CLEAR);
	    free(str);
	    return;
	}
	
	//legge tutto il file e lo decripta
	while(l=fread(str,1,100,file)){
	    decod(str,argv[3],l);
	    fwrite(str,l,1,output);
	}
	
	free(str);
	fclose(file);
	fclose(output);
	return 0;
    }

    //printa l'uso
    else if(!strcmp(argv[1],"-h") || !strcmp(argv[1],"--help")){
        use();
	free(str);
	return 1;
    }
    
    //opzione sconosciuta
    else{
	fprintf(stderr,"\n%s %s : Unknow option\n",RED,argv[1]);
	fprintf(stderr," Type \"%s -h\" for help%s\n\n",argv[0],CLEAR);
	free(str);
	return 1;
    }
}

void use(){
    fprintf(stderr,"\n%s Use: kryo { -c | -d } file key outputfile\n\n",BLUE);
    fprintf(stderr,"	-c , --crypt		Crypt file with the key\n");
    fprintf(stderr,"	-d , --decrypt		Try to decrypt file with the key\n");
    fprintf(stderr,"	-h , --help		Display this help\n\n");
    fprintf(stderr," Mail me at lesion@autistici.org for bugs!\n\n%s",CLEAR);
    return;
}

void cod(char *stringa, char *key,unsigned int stringalen){
int i,keylen;
    strcpy(key,(char *)crypt(key,"ab"));
    keylen=strlen(key);
    for(i=0;i<=stringalen;i++)
	stringa[i]=(stringa[i]^key[i%keylen])+30;
}

void decod(char *stringa, char *key,unsigned int stringalen){
 int i,keylen;
    //lo so' ke qui l'ab e' troppo leim, poi provvedo a pigliarlo 
    //dai primi 2 chars della pass
    strcpy(key,(char *)crypt(key,"ab"));
    keylen=strlen(key);
    for(i=0;i<=stringalen;i++)
	stringa[i]=(key[i%keylen]^(stringa[i]-30));
}

char *check(char *key){
 int i;
 char *str;
    str=(char *)malloc(4); 
    str[0]=str[1]=str[2]='\0';
    for (i=0;i<strlen(key)/2;i++)
	str[0]=str[0]^key[i];
    for (;i<strlen(key);i++)
	str[1]=str[1]^key[i];
    	if (str[0]=='\0') str[0]=' ';
	if (str[1]=='\0') str[1]=' ';
    return str;
}

int docheck(char *c,char *key){
 int i;
 char *ck;
    ck=check(key);
    if (!strcmp(c,ck)){
	free(ck);
	return 1;
    }
    free(ck);
    return 0;
}
